Imports System
Imports System.Collections




Public Class PersonCollection
    Implements IList
    Private arrList As New ArrayList

#Region "ICollection"


    Public Sub _CopyTo(ByVal array As System.Array, ByVal index As Integer) Implements System.Collections.ICollection.CopyTo
        arrList.CopyTo(array, index)
    End Sub

    Public ReadOnly Property Count() As Integer Implements System.Collections.ICollection.Count
        Get
            Return arrList.Count
        End Get
    End Property

    Public ReadOnly Property IsSynchronized() As Boolean Implements System.Collections.ICollection.IsSynchronized
        Get
            Return arrList.IsSynchronized
        End Get
    End Property

    Public ReadOnly Property SyncRoot() As Object Implements System.Collections.ICollection.SyncRoot
        Get
            Return Me
        End Get
    End Property

#End Region

#Region "IEnumerable"
    Public Function GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
        Return arrList.GetEnumerator()
    End Function

#End Region

    'Interface members are implemented using underscore to differentioate them from default interface members
    '(which these methods alla ctually are in VB)
#Region "IList"

    Public Function Add(ByVal value As Person) As Integer
        If value Is Nothing Then
            Throw New ArgumentNullException("value", "Collection does not accept null members")
        End If

        Return arrList.Add(value)

    End Function

    Public Function _Add(ByVal value As Object) As Integer Implements System.Collections.IList.Add
        If value Is Nothing Then
            Throw New ArgumentNullException("value", "Collection does not accept null members")
        End If

        If Not TypeOf (value) Is Person Then
            Throw New ArgumentException("Collection member must be of type Person", "value")
        End If

        Return Add(CType(value, Person))
    End Function

    Public Sub Clear()
        arrList.Clear()
    End Sub

    Public Sub _Clear() Implements System.Collections.IList.Clear
        Clear()
    End Sub

    Public Function Contains(ByVal value As Person) As Boolean
        If value Is Nothing Then
            Return False
        End If
        Return arrList.Contains(value)
    End Function

    Public Function _Contains(ByVal value As Object) As Boolean Implements System.Collections.IList.Contains
        If value Is Nothing Then
            Return False
        End If

        If Not TypeOf (value) Is Person Then
            Return False
        End If

        Return Contains(CType(value, Person))
    End Function

    Public Function IndexOf(ByVal value As Person) As Integer
        If value Is Nothing Then
            Return -1
        End If

        Return arrList.IndexOf(value)
    End Function

    Public Function _IndexOf(ByVal value As Object) As Integer Implements System.Collections.IList.IndexOf

        If value Is Nothing Then
            Return -1
        End If

        If Not TypeOf (value) Is Person Then
            Return -1
        End If

        Return IndexOf(CType(value, Person))

    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As Person)
        If value Is Nothing Then
            Throw New ArgumentNullException("value", "Collection does not accept null members")
        End If

        arrList.Insert(index, value)
    End Sub

    Public Sub _Insert(ByVal index As Integer, ByVal value As Object) Implements System.Collections.IList.Insert
        If value Is Nothing Then
            Throw New ArgumentNullException("value", "Collection does not accept null members")
        End If

        If Not TypeOf (value) Is Person Then
            Throw New ArgumentException("Collection member must be of type Person", "value")
        End If

        Insert(index, CType(value, Person))
    End Sub

    Public ReadOnly Property IsFixedSize() As Boolean
        Get
            Return arrList.IsFixedSize
        End Get
    End Property

    Public ReadOnly Property _IsFixedSize() As Boolean Implements System.Collections.IList.IsFixedSize
        Get
            Return IsFixedSize
        End Get
    End Property

    Public ReadOnly Property IsReadOnly() As Boolean
        Get
            Return arrList.IsReadOnly
        End Get
    End Property

    Public ReadOnly Property _IsReadOnly() As Boolean Implements System.Collections.IList.IsReadOnly
        Get
            Return IsReadOnly
        End Get
    End Property

    Public Property _Item(ByVal index As Integer) As Object Implements System.Collections.IList.Item
        Get
            Return CType(arrList(index), Person)
        End Get
        Set(ByVal Value As Object)
            If Not Value Is Nothing Then

                If Not TypeOf (Value) Is Person Then '
                    Throw New ArgumentException("Collection member must be of type Person", "value")
                Else
                    arrList(index) = CType(Value, Person)
                End If
            Else
                Throw New ArgumentNullException("value", "Collection does not accept null members")
            End If
        End Set
    End Property

    Default Public Property Item(ByVal index As Integer) As Person
        Get
            Return CType(arrList(index), Person)
        End Get
        Set(ByVal Value As Person)
            If Not Value Is Nothing Then
                arrList(index) = Value
            Else
                Throw New ArgumentNullException("value", "Collection does not accept null members")
            End If
        End Set
    End Property

    Public Sub Remove(ByVal value As Person)
        If value Is Nothing Then
            Throw New ArgumentNullException("value", "You cannot remove collection member using null reference")
        End If

        arrList.Remove(value)
    End Sub

    Public Sub _Remove(ByVal value As Object) Implements System.Collections.IList.Remove
        If value Is Nothing Then
            Throw New ArgumentNullException("value", "You cannot remove collection member using null reference")
        End If

        If Not TypeOf (value) Is Person Then '
            Throw New ArgumentException("You can remove only an object of type Person", "value")
        End If

        Remove(CType(value, Person))

    End Sub


    Public Sub RemoveAt(ByVal index As Integer)
        arrList.RemoveAt(index)
    End Sub

    Public Sub _RemoveAt(ByVal index As Integer) Implements System.Collections.IList.RemoveAt
        RemoveAt(index)
    End Sub

#End Region
End Class


